core/urls.py
from django.urls import path, include

from core import views

urlpatterns = [
    path('login/', views.LoginPage.as_view(), name = 'login'),
    path('logout/', views.LogoutPage.as_view(), name = 'logout'),
    path('', views.LandingPage.as_view(), name='landing'),
    # Admin
    path('admin-home/', views.AdminHome.as_view(), name = 'admin-home'),
    path('user/', views.CreateUser.as_view(), name = 'user'),
    path('user/<int:pk>/', views.EditUser.as_view(), name = 'edit-user'),
    path('user/<int:pk>/delete/', views.DeleteUser.as_view(), name = 'delete-user'),
]

docket/urls.py
from django.urls import path, include

from docket import views


urlpatterns = [
	path('', views.DocketHome.as_view(), name = 'home'),
    path('settings/', views.DocketSettingsPage.as_view(), name = 'settings'),
    path('sort/', views.SortPage.as_view(), name = 'sort'),
    path('filter/', views.FilterPage.as_view(), name = 'filter'),
    path('item/', views.CreateItem.as_view(), name = 'create-item'),
    path('item/<int:pk>/', views.EditItem.as_view(), name = 'edit-item'),
]

server/urls.py
"""cerrax-cloud URL Configuration
"""
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect

def redirect_view(request, uri, root=''):
    return redirect(root+uri, permanent=True)

urlpatterns = [

    # admin interface !! FOR DEV ONLY - NOT PRODUCTION !!
    path('admin/', admin.site.urls),

    # main website (Cerrax.com)
    path('', include(('website.urls', 'website'), namespace='website')),

    # Cerrax Cloud apps
    path('cloud/', include(('core.urls', 'core'), namespace='core')),
    path('cloud/lister/', include(('lister.urls', 'lister'), namespace='lister')),
    path('cloud/docket/', include(('docket.urls', 'docket'), namespace='docket')),
    path('cloud/arkham/', include(('arkham.urls', 'arkham'), namespace='arkham')),
    # redirect lister, since it it used frequently
    # deprecate this path and eventually disable it
    path('lister/<path:uri>', redirect_view, {'root':'/cloud/lister/'}),
    
]

docket/views.py
import logging
import datetime

from django.utils import timezone
from django.views import View
from django.core.exceptions import ObjectDoesNotExist, ValidationError
from django.utils.html import escape
from django.http import HttpResponse, HttpResponseRedirect, HttpResponseServerError
from django.shortcuts import render
from django.urls import reverse_lazy
from django.db.models import Q
from django.db.models.functions import Lower

from core.models import Apps, CerraxUser
from core.views import BaseView, CrudMixin
from core.utils import Color
from docket.models import DocketSorting, DocketStatus, DocketPriority, DocketCategory, DocketSettings, DocketItem, DocketItemUpdate


#-== @h1
# Docket Views
#-== /docket.views.py
#________________________________________


##########################################
#-== @class
class DocketBase(BaseView):
	#-== Sets the /app_permission for all derived views as /Apps.DOCKET .

	app_permission = Apps.DOCKET

	# ----------------------------------------------------
	#-== @method
	def initialize(self, request, *args, **kwargs):
		#-== Fetch the settings and categories associated with the request user.
		# This adds 2 additional attributes to the view class.
		# @attributes
		# self.settings: the /DocketSettings object for the user
		# self.categories: the /DocketCategory objects associated with the user

		self.settings = DocketSettings.objects.get_or_create(user=self.user)[0]
		self.categories = DocketCategory.objects.filter(user=self.user)
		if len(self.categories) == 0:
			DocketCategory.objects.create(user=self.user, name='Personal')
			DocketCategory.objects.create(user=self.user, name='Work')
			self.categories = DocketCategory.objects.filter(user=self.user)


##########################################
#-== @class
class DocketHome(DocketBase):
	#-== Shows all of the Docket items available to the user.
	# This list of items is sorted and filtered according to the
	# parameters chosen by the user on the Sort and Filter pages.

	page_title = 'Docket'
	back_url = reverse_lazy('core:landing')
	button_bar_left = [
		{'display': 'Sort', 'url': reverse_lazy('docket:sort') },
		{'display': 'Filter', 'url': reverse_lazy('docket:filter') },
	]
	button_bar_right = [
		{'display': '+ New Item', 'url': reverse_lazy('docket:create-item') },
		{'display': 'Settings', 'url': reverse_lazy('docket:settings') },
	]

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the docket items (sorted and filtered).

	def get(self, request, *args, **kwargs):

		self.purge_old_items()

		exclusions = self.settings.get_exclusions()
		sorting = self.settings.sorting
		items = DocketItem.objects.filter(user=self.user
			).exclude(**exclusions['statuses']
			).exclude(**exclusions['priorities']
			).exclude(**exclusions['categories']
			).order_by(sorting)

		for item in items:
			item.set_display()

		self.context['docketitems'] = items
		return render(request, 'docket/home.html', self.context)

	# ----------------------------------------------------
	#-== @method
	def purge_old_items(self):
		#-== Every time the view is requested, this method checks
		# for old /DocketItem objects and deletes them according
		# to the user's purge settings.

		purge_days = self.settings.purge_days
		if purge_days >= 0:
			purge_threshold = timezone.now() - datetime.timedelta(days=purge_days)
			old_items = DocketItem.objects.filter(user=self.user, last_update__lt=purge_threshold.date())
			num_deleted = old_items.delete()[0]
			if num_deleted > 0:
				self.logger.info('Purged {} items older than {} days'.format(num_deleted, purge_days))

##########################################
#-== @class
class SortPage(DocketBase):
	#-== Allows the user to select from a list of sorting options.

	page_title = 'Sort'
	back_url = reverse_lazy('docket:home')

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the available sorting options.

	def get(self, request, *args, **kwargs):
		direction = 'asc'
		sort = self.settings.sorting
		if sort[0] == '-':
			direction ='desc'
			sort = sort [1:]

		self.context['sort'] = {
			'direction': direction,
			'sort': sort,
		}

		return render(request, 'docket/sort.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Update the sorting to the selected sorting option.

	def post(self, request, *args, **kwargs):
		# set the direction of the sort (ascending or descending)
		directionstr = request.POST.get('direction')
		if not directionstr:
			self.log_error('Sort direction is invalid.')
		direction = ''
		if directionstr == 'asc':
			direction = ''
		elif directionstr == 'desc':
			direction = '-'
		else:
			self.log_error('Sort direction is invalid.')

		# get the field to sort by
		sortstr = request.POST.get('sort')
		for sort in DocketSorting.DATA:
			if sortstr == sort.fieldname:
				break
		else:
			self.log_error('Sort field is invalid.')

		# save to the settings object
		self.settings.sorting = direction+sortstr
		try:
			self.settings.save()
		except Exception as exc:
			self.log_error('An error occurred while trying to save sort settings.', exception=exc)

		return self.redirect('docket:home')

##########################################
#-== @class
class FilterPage(DocketBase):
	#-== Allows the user to select from a list of sorting options.

	page_title = 'Filter'
	back_url = reverse_lazy('docket:home')

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the available sorting options.

	def get(self, request, *args, **kwargs):

		self.context['status_open'] = True
		self.context['status_working'] = True
		self.context['status_onhold'] = True
		self.context['status_closed'] = True
		status_excludes = self.settings.get_excluded_statuses()
		if DocketStatus.OPEN in status_excludes:
			self.context['status_open'] = False
		if DocketStatus.WORKING in status_excludes:
			self.context['status_working'] = False
		if DocketStatus.ONHOLD in status_excludes:
			self.context['status_onhold'] = False
		if DocketStatus.CLOSED in status_excludes:
			self.context['status_closed'] = False

		self.context['priority_low'] = True
		self.context['priority_medium'] = True
		self.context['priority_high'] = True
		priority_excludes = self.settings.get_excluded_priorities()
		if DocketPriority.LOW in priority_excludes:
			self.context['priority_low'] = False
		if DocketPriority.MEDIUM in priority_excludes:
			self.context['priority_medium'] = False
		if DocketPriority.HIGH in priority_excludes:
			self.context['priority_high'] = False

		self.context['categories'] = DocketCategory.objects.filter(user=self.user)

		return render(request, 'docket/filter.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Update the sorting to the selected sorting option.

	def post(self, request, *args, **kwargs):
		exclude_stats = []
		if not request.POST.get('status_open', False):
			exclude_stats.append(str(DocketStatus.OPEN.value))
		if not request.POST.get('status_working', False):
			exclude_stats.append(str(DocketStatus.WORKING.value))
		if not request.POST.get('status_onhold', False):
			exclude_stats.append(str(DocketStatus.ONHOLD.value))
		if not request.POST.get('status_closed', False):
			exclude_stats.append(str(DocketStatus.CLOSED.value))

		self.settings.filter_hide_status = ','.join(exclude_stats)

		exclude_pris = []
		if not request.POST.get('priority_low', False):
			exclude_pris.append(str(DocketPriority.LOW.value))
		if not request.POST.get('priority_medium', False):
			exclude_pris.append(str(DocketPriority.MEDIUM.value))
		if not request.POST.get('priority_high', False):
			exclude_pris.append(str(DocketPriority.HIGH.value))

		self.settings.filter_hide_priority = ','.join(exclude_pris)

		try:
			self.settings.save()
		except Exception as exc:
			self.log_error('An error occurred while trying to save status and priority filters.', exception=exc)

		categories = DocketCategory.objects.filter(user=self.user)
		for cat in categories:
			cat.hide_items = not bool(request.POST.get('category_{}'.format(cat.id), False))
			try:
				cat.save()
			except Exception as exc:
				self.log_error('An error occurred while trying to save a category filter.', exception=exc)

		return self.redirect('docket:home')

##########################################
#-== @class
class DocketSettingsPage(DocketBase):
	#-== A page to adjust the /DocketSettings and /DocketCategory objects of the user.

	page_title = 'Settings'
	back_url = reverse_lazy('docket:home')

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the user's current settings within the /docket\/settings.html template.

	def get(self, request, *args, **kwargs):
		self.context['settings'] = self.settings
		self.context['categories'] = self.categories

		return render(request, 'docket/settings.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Adjust the settings based on the data received from the form.

	def post(self, request, *args, **kwargs):
		print(request.POST)

		self.update_setting(request, 'update_new_color')
		self.update_setting(request, 'update_aging_days')
		self.update_setting(request, 'update_aging_color')
		self.update_setting(request, 'update_old_days')
		self.update_setting(request, 'update_old_color')
		self.update_setting(request, 'update_purge_warning')
		self.update_setting(request, 'update_purge_color')
		self.update_setting(request, 'purge_days')
		self.update_setting(request, 'status_open_color')
		self.update_setting(request, 'status_working_color')
		self.update_setting(request, 'status_onhold_color')
		self.update_setting(request, 'status_closed_color')
		self.update_setting(request, 'priority_low_color')
		self.update_setting(request, 'priority_medium_color')
		self.update_setting(request, 'priority_high_color')

		try:

docket/templates/docket/filter.html
{% extends 'core/base.html' %}
{% load static %}

{% block header %}
<link rel="stylesheet" type="text/css" href="{% static 'docket/css/docket.css' %}">
{% endblock %}

{% block content %}
<form id="filter-form" method="POST">
	{% csrf_token %}

	<!-- Status, Priority, Category -->
	<div>Status</div>
	<div class="list">
		<div class="sort-tile">
			<div class="sort-tile">
				<input class="" type="checkbox" name="status_open"
					value="true" {% if status_open %}checked{% endif %}  />
				<label>Open</label>
			</div>
			<div class="sort-tile">
				<input class="" type="checkbox" name="status_working"
					value="true" {% if status_working %}checked{% endif %}  />
				<label>Working</label>
			</div>
		</div>
		<div class="sort-tile">
			<div class="sort-tile">
				<input class="" type="checkbox" name="status_onhold"
					value="true" {% if status_onhold %}checked{% endif %}  />
				<label>On Hold</label>
			</div>
			<div class="sort-tile">
				<input class="" type="checkbox" name="status_closed"
					value="true" {% if status_closed %}checked{% endif %}  />
				<label>Closed</label>
			</div>
		</div>
	</div>

	<div>Priority</div>
	<div class="list">
		<div class="sort-tile">
			<div class="sort-tile">
				<input class="" type="checkbox" name="priority_low"
					value="true" {% if priority_low %}checked{% endif %}  />
				<label>Low</label>
			</div>
			<div class="sort-tile">
				<input class="" type="checkbox" name="priority_medium"
					value="true" {% if priority_medium %}checked{% endif %}  />
				<label>Medium</label>
			</div>
		</div>
		<div class="sort-tile">
			<div class="sort-tile">
				<input class="" type="checkbox" name="priority_high"
					value="true" {% if priority_high %}checked{% endif %}  />
				<label>High</label>
			</div>
		</div>
	</div>

	<div>Categories</div>
	<div class="list">
		{% for cat in categories %}
		<div class="sort-tile">
			<input class="" type="checkbox" name="category_{{cat.id}}"
				value="true" {% if not cat.hide_items %}checked{% endif %}  />
			<label>{{ cat.name }}</label>
		</div>
		{% endfor %}
	</div>

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

docket/templates/docket/home.html
{% extends 'core/base.html' %}
{% load static %}

{% block header %}
<link rel="stylesheet" type="text/css" href="{% static 'docket/css/docket.css' %}">
{% endblock %}

{% block content %}
<div class="list">
	{% for item in docketitems %}
	<a href="{% url 'docket:edit-item' item.id %}">
		<div class="list-item docket-item">
			<div class="docket-info">
				<div class="docket-lead-line">
					<div class="docket-item-title">{{ item.title|escape }}</div>
					<div class="docket-item-status" style="color:{{ item.status_fore_color }};background-color:{{ item.status_bg_color }};">
						{{ item.status_display }}
					</div>
				</div>

				<div class="docket-item-last_update">
					{{ item.latest_update_text|escape }}
				</div>

				<div class="stretchflex">
					<div class="docket-item-priority" style="color:{{ item.priority_fore_color }};background-color:{{ item.priority_bg_color }};">
						{{ item.priority_display }}
					</div>
					
					<div class="docket-item-created">{{ item.created|date:"M d, Y" }}</div>
					<div class="docket-item-updated" style="color:{{ item.last_update_fore_color }};background-color:{{ item.last_update_bg_color }};">
						{{ item.last_update|date:"M d, Y" }}
					</div>
				</div>
			</div>
			<div class="docket-status-bar" style="background-color:{{ item.status_bg_color }};"></div>
		</div>
	</a>
	{% endfor %}
	{% if not docketitems %}
	<div class="emptyDocket">You have nothing on your docket!</div>
	{% endif %}
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

docket/templates/docket/item.html
{% extends 'core/base.html' %}
{% load static %}

{% block header %}
<link rel="stylesheet" type="text/css" href="{% static 'docket/css/docket.css' %}">
{% endblock %}

{% block content %}
<script>
	var statuses = {
		{% for stat in statuses %}
		{{ stat.id }}: { bg_color: "{{ stat.bg_color }}", fore_color: "{{ stat.fore_color }}" },
		{% endfor %}
	}
	var priorities = {
		{% for pri in priorities %}
		{{ pri.id }}: { bg_color: "{{ pri.bg_color }}", fore_color: "{{ pri.fore_color }}" },
		{% endfor %}
	}
</script>
<script src="{% static 'docket/js/edititem.js' %}"></script>
<form id="edit-item-form" method="POST">
	{% csrf_token %}

	<div class="flexdiv">
		<label>Title</label>
		<input type="text" class="docket-input"
			name="title" value="{{ item.title|escape }}" />
	</div>

	<div class="flexdiv">
		<label>Category</label>
		<select name="category" class="docket-input">
			{% for cat in categories %}
			<option {% if cat.id == item.category.id %}selected{% endif %} value="{{ cat.id }}">{{ cat.name }}</option>
			{% endfor %}
		</select>
	</div>

	<div class="flexdiv">
		<label>Priority</label>
		<select id="priorityDropdown" class="docket-item-priority"
			name="priority" style="color:{{ item.priority_fore_color }};background-color:{{ item.priority_bg_color }};">
			{% for pri in priorities %}
			<option {% if pri.id == item.priority %}selected{% endif %} value="{{ pri.id }}">{{ pri.text }}</option>
			{% endfor %}
		</select>

		<label>Status</label>
		<select id="statusDropdown" class="docket-item-status"
			name="status" style="color:{{ item.status_fore_color }};background-color:{{ item.status_bg_color }};">
			{% for stat in statuses %}
			<option {% if stat.id == item.status %}selected{% endif %} value="{{ stat.id }}">{{ stat.text }}</option>
			{% endfor %}
		</select>
	</div>

	<div class="flexdiv">
		<label>Contact</label>
		<input type="text" class="docket-input" 
			name="contact" value="{{ item.contact|escape }}" />
	</div>

	<div class="flexdiv">
		<div class="docket-item-date-container">
			<label class="nopadd">Created</label>
			<div class="docket-item-date">
				{{ item.created|date:"M d, Y" }}
			</div>
		</div>

		<div class="docket-item-date-container"  style="color:{{ item.last_update_fore_color }};background-color:{{ item.last_update_bg_color }};">
			<label class="nopadd" style="color:{{ item.last_update_fore_color }};">Updated</label>
			<div class="docket-item-date">
				{{ item.last_update|date:"M d, Y" }}
			</div>
		</div>
	</div>

	<label>New Update</label>
	<textarea name="newupdate" maxlength="250" rows="5" value="{{ newupdate }}"></textarea>

	<input type="submit" value="Save" />

	<label>History</label>

	<div class="list">
		{% for entry in extra.history %}
		<div class="history-entry">
			<div class="history-date">{{ entry.created|date:"l, M d, Y" }}</div>
			<div class="history-text">{{ entry.text|escape }}</div>
		</div>
		{% endfor %}
	</div>

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

docket/templates/docket/settings.html
{% extends 'core/base.html' %}
{% load static %}

{% block header %}
<link rel="stylesheet" type="text/css" href="{% static 'docket/css/docket.css' %}">
{% endblock %}

{% block content %}
<form id="edit-item-form" method="POST">
	{% csrf_token %}

	<div class="flexdiv">
		<label>Purge items after</label>
		<input class="smallNumber" type="number" size="4" 
			name="purge_days" value="{{ settings.purge_days }}" />
		<label>days</label>
	</div>

	<div class="">Update Colors</div>

	<div class="flexdiv">
		<input type="color" name="update_new_color" value="{{ settings.update_new_color }}" />
		<label>New</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="update_aging_color" value="{{ settings.update_aging_color }}" />
		<label>After</label>
		<input class="smallNumber" type="number" size="4"
			name="update_aging_days" size="3" value="{{ settings.update_aging_days }}" />
		<label>days</label>
	</div>

	<div class="flexdiv">
		<input type="color" name="update_old_color" value="{{ settings.update_old_color }}" />
		<label>After</label>
		<input class="smallNumber" type="number" size="4"
			name="update_old_days" size="3" value="{{ settings.update_old_days }}" />
		<label>days</label>
	</div>

	<div class="flexdiv">
		<input type="color" name="update_purge_color" value="{{ settings.update_purge_color }}" />
		<label>Within</label>
		<input class="smallNumber" type="number" size="4"
			name="update_purge_warning" size="3" value="{{ settings.update_purge_warning }}" />
		<label>days of purge</label>
	</div>

	<div class="">Priority Colors</div>

	<div class="flexdiv">
		<input type="color" name="priority_low_color" value="{{ settings.priority_low_color }}" />
		<label>Low</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="priority_medium_color" value="{{ settings.priority_medium_color }}" />
		<label>Medium</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="priority_high_color" value="{{ settings.priority_high_color }}" />
		<label>High</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="">Status Colors</div>

	<div class="flexdiv">
		<input type="color" name="status_open_color" value="{{ settings.status_open_color }}" />
		<label>Open</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="status_working_color" value="{{ settings.status_working_color }}" />
		<label>Working</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="status_onhold_color" value="{{ settings.status_onhold_color }}" />
		<label>On Hold</label>
		<input class="settingSpacer" type="text" />
	</div>

	<div class="flexdiv">
		<input type="color" name="status_closed_color" value="{{ settings.status_closed_color }}" />
		<label>Closed</label>
		<input class="settingSpacer" type="text" />
	</div>

	<input type="submit" value="Save" />

	<div id="categories" class="">Categories</div>

	{% for cat in categories %}
	<div class="flexdiv">
		<input type="text" name="category_{{ cat.id }}" value="{{ cat.name }}" />
		<button class="warning-color" type="submit" value="{{ cat.id }}" name="submit_deletecategory">X</button>
	</div>
	{% endfor %}

	<div class="flexdiv">
		<button type="submit" value="+" name="submit_newcategory">+</button>
		<input type="text" name="newcategory" value="" />
	</div>

	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

docket/templates/docket/sort.html
{% extends 'core/base.html' %}
{% load static %}
{% load core_components %}

{% block header %}
<link rel="stylesheet" type="text/css" href="{% static 'docket/css/docket.css' %}">
{% endblock %}

{% block content %}
<form id="sorting-form" method="POST">
	{% csrf_token %}

	<div>Sort Direction</div>
	<fieldset class="sort-tile">
		<div class="sort-tile">
			<div class="sort-tile">
				<input type="radio" name="direction" value="asc" {% if sort.direction == 'asc' %}checked{% endif %} />
				<label>Ascending</label>
			</div>
			<div class="sort-tile">
				<input type="radio" name="direction" value="desc" {% if sort.direction == 'desc' %}checked{% endif %} />
				<label>Descending</label>
			</div>
		</div>

	</fieldset>

	<div>Sort by:</div>
	<fieldset class="list">

		<div class="sort-tile">
			<div class="sort-tile">
				<input type="radio" name="sort" value="title" {% if sort.sort == 'title' %}checked{% endif %} />
				<label>Title</label>
			</div>
			<div class="sort-tile">
				<input type="radio" name="sort" value="category" {% if sort.sort == 'category' %}checked{% endif %} />
				<label>Category</label>
			</div>
		</div>

		<div class="sort-tile">
			<div class="sort-tile">
				<input type="radio" name="sort" value="priority" {% if sort.sort == 'priority' %}checked{% endif %} />
				<label>Priority</label>
			</div>
			<div class="sort-tile">
				<input type="radio" name="sort" value="status" {% if sort.sort == 'status' %}checked{% endif %} />
				<label>Status</label>
			</div>
		</div>

		<div class="sort-tile">
			<div class="sort-tile">
				<input type="radio" name="sort" value="created" {% if sort.sort == 'created' %}checked{% endif %} />
				<label>Created</label>
			</div>
			<div class="sort-tile">
				<input type="radio" name="sort" value="last_update" {% if sort.sort == 'last_update' %}checked{% endif %} />
				<label>Updated</label>
			</div>
		</div>

	</fieldset>

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}